#include "/lib/config.glsl"

/* Color utils */

#ifdef THE_END
    #include "/lib/color_utils_end.glsl"
#elif defined NETHER
    #include "/lib/color_utils_nether.glsl"
#else
    #include "/lib/color_utils.glsl"
#endif

/* Uniforms */

uniform sampler2D gaux3;

/* Ins / Outs */

varying vec2 texcoord;
varying float exposure;

#include "/lib/luma.glsl"

void main() {
    gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
    texcoord = gl_MultiTexCoord0.xy;

    // Tonemaping ---
    // x: Block, y: Sky ---
    #if !defined UNKNOWN_DIM
        exposure = texture2D(gaux3, vec2(0.5)).r;
    #else
        exposure = 1.0;
    #endif
}
